#pragma once

#include "network/TCPListener.h"
#include "network/TCPClient.h"
#include "Protocol.h"
#include "NetworkMessage.h"

namespace Feather
{
    class MinecraftClient
    {
    public:
        MinecraftClient(Network::TCPClientHandle&& client);
        ~MinecraftClient();

        inline Network::TCPClientHandle& GetTCPClient() { return m_client; }
        inline ProtocolContext& GetContext() { return m_context; }

        void SendMessage(const NetworkMessage& message);

    private:
        Network::TCPClientHandle m_client;
        ProtocolContext          m_context;
    };
}
