#pragma once

#include <cstdint>
#include <memory>

struct bufferevent;
struct sockaddr;

namespace Feather::Network
{
#ifdef _WIN32
    using SocketHandle = intptr_t;
#else
    using SocketHandle = int;
#endif

    struct SocketAddress;

    class IListenerInterface;
    class TCPListener;
    class TCPSocket;
    class TCPClient;

    using TCPClientHandle = std::unique_ptr<TCPClient>;
}